import * as React from "react";
import { Animated, ViewStyle, StyleProp, TextStyle, ImageStyle, ImageSourcePropType } from "react-native";
declare type CustomStyleProp = StyleProp<ViewStyle> | Array<StyleProp<ViewStyle>>;
declare type CustomTextStyleProp = StyleProp<TextStyle> | Array<StyleProp<TextStyle>>;
declare type CustomImageStyleProp = StyleProp<ImageStyle> | Array<StyleProp<ImageStyle>>;
interface ISwitchButtonProps {
    style?: CustomStyleProp;
    textStyle?: CustomTextStyleProp;
    imageStyle?: CustomImageStyleProp;
    textContainerStyle?: CustomTextStyleProp;
    activeImageSource: ImageSourcePropType;
    inactiveImageSource: ImageSourcePropType;
    text?: string;
    mainColor?: string;
    tintColor?: string;
    isActive?: boolean;
    disableText?: boolean;
    originalColor?: string;
    onPress: (isActive: boolean) => void;
}
interface IState {
    isActive: boolean;
}
export default class SwitchButton extends React.Component<ISwitchButtonProps, IState> {
    interpolatedColor: Animated.Value;
    constructor(props: ISwitchButtonProps);
    componentDidMount(): void;
    handleActiveState: () => void;
    showOriginColor: () => void;
    showFocusColor: () => void;
    handlePress: () => void;
    renderBounceableButton: () => JSX.Element;
    renderText: () => false | JSX.Element;
    render(): JSX.Element;
}
export {};
