"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const React = tslib_1.__importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_bounceable_1 = tslib_1.__importDefault(require("@freakycoder/react-native-bounceable"));
/**
 * ? Local Imports
 */
const SwitchButton_style_1 = tslib_1.__importStar(require("./SwitchButton.style"));
const AnimatedRNBounceable = react_native_1.Animated.createAnimatedComponent(react_native_bounceable_1.default);
const MAIN_COLOR = "#f1bb7b";
const ORIGINAL_COLOR = "#fff";
const TINT_COLOR = "#f1bb7b";
const ORIGINAL_VALUE = 0;
const ANIMATED_VALUE = 1;
class SwitchButton extends React.Component {
    constructor(props) {
        super(props);
        this.handleActiveState = () => {
            if (this.props.isActive) {
                this.setState({ isActive: !this.state.isActive }, () => {
                    this.state.isActive ? this.showFocusColor() : this.showOriginColor();
                });
            }
        };
        this.showOriginColor = () => {
            react_native_1.Animated.timing(this.interpolatedColor, {
                duration: 350,
                toValue: ORIGINAL_VALUE,
                useNativeDriver: false,
            }).start();
        };
        this.showFocusColor = () => {
            react_native_1.Animated.timing(this.interpolatedColor, {
                duration: 450,
                toValue: ANIMATED_VALUE,
                useNativeDriver: false,
            }).start();
        };
        this.handlePress = () => {
            this.setState({ isActive: !this.state.isActive }, () => {
                this.state.isActive ? this.showFocusColor() : this.showOriginColor();
                this.props.onPress && this.props.onPress(this.state.isActive);
            });
        };
        /* -------------------------------------------------------------------------- */
        /*                               Render Methods                               */
        /* -------------------------------------------------------------------------- */
        this.renderBounceableButton = () => {
            const { style, imageStyle, activeImageSource, inactiveImageSource, } = this.props;
            const mainColor = this.props.mainColor || MAIN_COLOR;
            const originalColor = this.props.originalColor || ORIGINAL_COLOR;
            const tintColor = this.props.tintColor || TINT_COLOR;
            const _animatedBGColorOutputRange = this.state.isActive
                ? [mainColor, originalColor]
                : [originalColor, mainColor];
            const _animatedTintColorOutputRange = this.state.isActive
                ? [originalColor, tintColor]
                : [tintColor, originalColor];
            let animatedBackgroundColor = this.interpolatedColor.interpolate({
                inputRange: [ORIGINAL_VALUE, ANIMATED_VALUE],
                outputRange: [originalColor, mainColor],
            });
            let animatedTintColor = this.interpolatedColor.interpolate({
                inputRange: [ORIGINAL_VALUE, ANIMATED_VALUE],
                outputRange: [tintColor, originalColor],
            });
            return (<AnimatedRNBounceable style={[SwitchButton_style_1._containerStyle(animatedBackgroundColor), style]} onPress={this.handlePress}>
        <react_native_1.Animated.Image source={this.state.isActive ? activeImageSource : inactiveImageSource} style={[SwitchButton_style_1._imageStyle(animatedTintColor), imageStyle]}/>
      </AnimatedRNBounceable>);
        };
        this.renderText = () => {
            const { text, textStyle, textContainerStyle } = this.props;
            return (!this.props.disableText && (<react_native_1.View style={[SwitchButton_style_1.default.textContainerStyle, textContainerStyle]}>
          <react_native_1.Text style={textStyle}>{text}</react_native_1.Text>
        </react_native_1.View>));
        };
        this.interpolatedColor = new react_native_1.Animated.Value(ORIGINAL_VALUE);
        this.state = {
            isActive: false,
        };
    }
    componentDidMount() {
        this.handleActiveState();
    }
    render() {
        return (<react_native_1.View style={SwitchButton_style_1.default.container}>
        {this.renderBounceableButton()}
        {this.renderText()}
      </react_native_1.View>);
    }
}
exports.default = SwitchButton;
//# sourceMappingURL=SwitchButton.js.map